"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _style = require("@amaui/style");

var _ = require(".");

const _excluded = ["children", "className"];

const styled = Element => (value, options_ = {}) => {
  // Use styles
  const useStyle = (0, _.style)(value, options_); // Element

  const element = /*#__PURE__*/_react.default.forwardRef((props, ref) => {
    const {
      children,
      className: classNameProp
    } = props,
          other = (0, _objectWithoutProperties2.default)(props, _excluded);
    const styles = useStyle(props);
    return /*#__PURE__*/_react.default.createElement(Element, (0, _extends2.default)({
      ref: ref,
      className: (0, _style.classNames)([classNameProp, styles.class])
    }, other), children);
  });

  return element;
};

var _default = styled;
exports.default = _default;