"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _ = require(".");

const withStyle = Element => (value, options_ = {}) => {
  // Use styles
  const useStyle = (0, _.style)(value, options_); // Element

  const element = /*#__PURE__*/_react.default.forwardRef((props, ref) => {
    const styles = useStyle(props);
    return /*#__PURE__*/_react.default.createElement(Element, (0, _extends2.default)({
      ref: ref,
      styles: styles
    }, props));
  });

  return element;
};

var _default = withStyle;
exports.default = _default;